package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_INFRA_TYPE", schema = "public")
public class MetaInfraType {
  private Short id;
  private String key;
  private String name;
  private Date createDate;

  public MetaInfraType() {
  }

  public MetaInfraType(Short id) {
    this.id = id;
  }

  @Id
  public Short getId() {
    return id;
  }

  public void setId(Short id) {
    this.id = id;
  }

  @Column(name = "KEY", nullable = true, length = 50)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "NAME", nullable = true, length = 50)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public static enum Enum {
    ZONE((short)1),
    HOST((short)2),
    SERVICE((short)3),
    ;

    private final Short value;

    /**
     * @param value
     */
    Enum(final Short value) {
      this.value = value;
    }

    public MetaInfraType to() {
      return new MetaInfraType(this.value);
    }
  }
}
