package com.loafle.overflow.service.central.target;

import java.util.List;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.target.Target;
import org.springframework.data.domain.Page;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface TargetService {

  Target regist(Target target, Long probeID) throws OverflowException;

  @WebappAPI
  List<Target> registAll(List<Target> targets, Long probeID) throws OverflowException;

  @WebappAPI
  void remove(Long id, Long probeID) throws OverflowException;

  @WebappAPI
  Target read(Long id) throws OverflowException;

  @WebappAPI
  Target modify(Target target) throws OverflowException;

  @WebappAPI
  Page<Target> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException;

  Target increaseSensorCount(Long id) throws OverflowException;
  
  Target decreaseSensorCount(Long id) throws OverflowException;

}
